# clm version and release
%define clmver     3
%define version    2004.12.20
%define release    1
%define ver        %{nil}

# lisp versions and lisp specific clm package releases
%define cmucl_ver  2004.11
%define cmucl_rel  1
%define sbcl_ver   0.8.16
%define sbcl_rel   1

# for which lisp we are building
%define cmucl_build 1
%define sbcl_build  1

# --without alsa: build for oss api (default is alsa)
%define alsa        %{?_without_alsa:0}%{!?_without_alsa:1}

# --without-jack: disable jack support
%define jack        %{?_without_jack:0}%{!?_without_jack:1}

# various locations
%define cmucl_clm_bin_dir %{_libdir}/cmucl/lib/clm%{ver}
%define cmucl_subsystems  %{_libdir}/cmucl/lib/subsystems
%define sbcl_clm_bin_dir  %{_libdir}/sbcl/clm%{ver}
%define sbcl_subsystems   %{_libdir}/sbcl/site-systems
%define clm_src_dir       %{_datadir}/common-lisp/source/clm%{ver}

Summary:      Common Lisp Music (CLM-%{clmver}, %{version})
Name:         clm
Version:      %{version}
Release:      %{release}
License:      GPL
Group:        Development/Languages
URL:          http://ccrma.stanford.edu/software/clm
Source0:      clm-%{clmver}.tar.gz
BuildRoot:    %{_tmppath}/%{name}-%{version}-%{release}-root
Packager:     Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

Obsoletes:    clm-source

%if "%{cmucl_build}" == "1"
BuildRequires: cmucl = %{cmucl_ver}
%endif
%if "%{sbcl_build}" == "1"
BuildRequires: sbcl = %{sbcl_ver}, tcsh
%endif
BuildRequires: XFree86-devel
BuildRequires: alsa-lib-devel libsamplerate-devel
BuildRequires: jack-audio-connection-kit-devel

%description
This package contains CLM-%{clmver} [%{version}] (Common Lisp Music)
source and documentation.

Common Lisp Music, by Bill Schottstaedt (CLM, for lack of a catchier
name), is a music synthesis and signal processing package in the Music
V family.

%package   cmucl
Summary:   Common Lisp Music binaries for CMUCL (CLM-%{clmver}, %{version})
Release:   %{cmucl_rel}
Group:     Development/Languages
Requires:  cmucl = %{cmucl_ver}
Requires:  clm%{ver} = %{version}-%{release}
Requires:  gcc
Obsoletes: cmucl-clm cmucl-cm-clm cmucl-cm-clm-cmn

%description cmucl
This package contains CLM-%{clmver} [%{version}] (Common Lisp Music)
binaries built on top of CMUCL Common Lisp.

%package   sbcl
Summary:   Common Lisp Music binaries for SBCL (CLM-%{clmver}, %{version})
Release:   %{sbcl_rel}
Group:     Development/Languages
Requires:  sbcl = %{sbcl_ver}
Requires:  clm%{ver} = %{version}-%{release}
Requires:  gcc

%description sbcl
This package contains CLM-%{clmver} [%{version}] (Common Lisp Music) 
built on top of SBCL Common Lisp.

%prep
%setup -q -n clm-%{clmver}

%build
# save a copy of the patched source
%{__tar} cf .clm.tar *

%if %{cmucl_build}
%{__mkdir} bin-cmucl
# define a cmucl subsystem to load clm
%{__cat} <<EOF >clm%{ver}-cmucl-library.lisp
;;;
;;; CMUCL Common Lisp Music (CLM%{ver}) startup code
;;;
(format t ";;;~%;;; Loading CLM-%{clmver} %{version}...~%;;;~%")
(setf *compile-print* nil)
(defparameter clm-directory "%{clm_src_dir}/")
(defparameter clm-bin-directory "%{cmucl_clm_bin_dir}/")
(load "%{clm_src_dir}/all.lisp")
(in-package :clm)
(setf *clm-player* "%{cmucl_clm_bin_dir}/sndplay")
(format t ";;;~%;;; CLM-%{clmver} %{version} loaded~%;;;~%")
EOF

# build clm
/usr/bin/lisp <<EOF
;; fix problems with signed arrays
(pushnew :signed-array *features*)
(setf *compile-print* nil)
(in-package :cl-user)
%if "%{alsa}" == "1"
(push :alsa *features*)
%endif
%if "%{jack}" == "1"
(push :jack *features*)
%endif
(defparameter clm-directory "./")
(defparameter clm-bin-directory "bin-cmucl/")
(load "all.lisp")
(compile-file "clm%{ver}-cmucl-library.lisp")
(quit)
EOF
%endif

%if %{sbcl_build}
%{__mkdir} bin-sbcl
# define a sbcl subsystem to load clm
%{__cat} <<EOF >clm%{ver}.asd
;;;
;;; SBCL Common Lisp Music (CLM%{ver}) startup code
;;;
(format t ";;;~%;;; Loading CLM-%{clmver} %{version}...~%;;;~%")
;; turn of some error reporting, see 
;; http://sbcl.sourceforge.net/manual/Controlling-Verbosity.html
(declaim (sb-ext:muffle-conditions style-warning sb-ext:compiler-note))
(declaim (sb-ext:muffle-conditions sb-ext:code-deletion-note))
(setf *compile-print* nil)
(defparameter clm-directory "%{clm_src_dir}/")
(defparameter clm-bin-directory "%{sbcl_clm_bin_dir}/")
(load "%{clm_src_dir}/all.lisp")
(in-package :clm)
(setf *clm-player* "%{sbcl_clm_bin_dir}/sndplay")
(format t ";;;~%;;; CLM-%{clmver} %{version} loaded~%;;;~%")
EOF

# build clm
/usr/bin/sbcl <<EOF
(setf *compile-print* nil)
(declaim (sb-ext:muffle-conditions style-warning sb-ext:compiler-note))
(declaim (sb-ext:muffle-conditions sb-ext:code-deletion-note))
(in-package :cl-user)
%if "%{alsa}" == "1"
(push :alsa *features*)
%endif
%if "%{jack}" == "1"
(push :jack *features*)
%endif
(defparameter clm-directory "./")
(defparameter clm-bin-directory "bin-sbcl/")
(load "all.lisp")
(compile-file "clm%{ver}.asd")
(quit)
EOF
%endif


%install
%{__rm} -rf %{buildroot}

%{__mkdir} -p %{buildroot}%{_bindir}
%{__mkdir} -p %{buildroot}%{clm_src_dir}
%{__mkdir} -p %{buildroot}%{_docdir}

# copy the patched source tree, this is going to be *clm-directory*
(cd %{buildroot}%{clm_src_dir}; \
 %{__tar} xpf %{_builddir}/clm-%{clmver}/.clm.tar; \
 %{__mv} clm-%{clmver}/* . ; %{__rmdir} clm-%{clmver})

# CMUCL install
%if %{cmucl_build}
%{__mkdir} -p %{buildroot}%{cmucl_clm_bin_dir}
%{__mkdir} -p %{buildroot}%{cmucl_subsystems}

(cd %{_builddir}/clm-%{clmver}/bin-cmucl; %{__tar} cf - *)| \
(cd %{buildroot}%{cmucl_clm_bin_dir}; %{__tar} xpf -)

# install the configuration stuff in the source directory
%{__cp} -p configure config.h %{buildroot}%{clm_src_dir}

# install the load subsystem
%{__cp} -p clm%{ver}-cmucl-library.x86f %{buildroot}%{cmucl_subsystems}/clm%{ver}-library.x86f

# the clm startup script
%{__cat} <<EOF >%{buildroot}%{_bindir}/clm%{ver}-cmucl
#!/bin/bash
# CLM%{ver} startup script for cmucl
exec /usr/bin/lisp -load "%{cmucl_subsystems}/clm%{ver}-library" $@
EOF
%{__chmod} 0755 %{buildroot}%{_bindir}/clm%{ver}-cmucl
%endif

# SBCL install
%if %{sbcl_build}
%{__mkdir} -p %{buildroot}%{sbcl_clm_bin_dir}
%{__mkdir} -p %{buildroot}%{sbcl_subsystems}

(cd %{_builddir}/clm-%{clmver}/bin-sbcl; %{__tar} cf - *)| \
(cd %{buildroot}%{sbcl_clm_bin_dir}; %{__tar} xpf -)

# install the configuration stuff in the source directory
%{__cp} -p configure config.h %{buildroot}%{clm_src_dir}

# install the load subsystem
%{__cp} -p clm%{ver}.asd %{buildroot}%{sbcl_subsystems}

# the clm startup script
%{__cat} <<EOF >%{buildroot}%{_bindir}/clm%{ver}-sbcl
#!/bin/bash
# CLM%{ver} startup script for sbcl
exec /usr/bin/sbcl --load "%{sbcl_subsystems}/clm%{ver}.asd" $@
EOF
%{__chmod} 0755 %{buildroot}%{_bindir}/clm%{ver}-sbcl
%endif

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc
%{clm_src_dir}

%if %{cmucl_build}
%files cmucl
%defattr(-,root,root,-)
%{cmucl_clm_bin_dir}
%{cmucl_subsystems}/*
%{_bindir}/*cmucl
%endif

%if %{sbcl_build}
%files sbcl
%defattr(-,root,root,-)
%{sbcl_clm_bin_dir}
%{sbcl_subsystems}/*
%{_bindir}/*sbcl
%endif

%changelog
* Fri Dec 24 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.12.20
- updated to 2004.12.20
- spec file cleanup
- turn off style warnings in sbcl (thanks to Rick Taube)
* Fri Nov  5 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- split packages, created old clm2 packages for backwards compatibility,
  plain clm packages are now clm3 (this spec file)
- removed support for clisp, it is no longer supported in clm3
- added support for sbcl in clm3, using the asdf utility:
  http://www.cliki.net/asdf
* Wed Oct 20 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- added patch to check for configure in the system directory in all.lisp
- todo: add default player?
* Sun Oct 17 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.08.30-1
- updated to end of life clm2 release
- add patch to include config.h from the bin-directory
- add patch1 to make-integer-array so that it uses signed integers under cmucl
- add feature to turn on signed arrays under cmucl (seems to work fine, at
  least with the 2004.10 cmucl snapshot)
* Wed May 19 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.05.19-1
- updated to 2004.05.19
- added /usr/bin/sndplay require to clm-clisp
* Tue May 11 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.05.06-1
- updated to 2004.05.06, build with cmucl 2004.05
* Sat May  8 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added proper buildrequires
* Fri Mar 12 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.03.10-1
- updated to 2004.03.10
* Mon Feb  9 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.02.09-1
- updated to 2004.02.09
* Tue Feb  4 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- clisp: suppress redefinition warnings during load
* Mon Feb  2 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.02.02-1
- updated to 2004.02.02
* Wed Jan 28 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2003.12.28-1
- updated to 2004.01.28
* Wed Jan 21 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2003.12.15-1
- too many changes to document
- for now do not activate jack support for clisp
- cmucl: use the internal sndplay command with jack support
* Sat Jan 17 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2003.12.15-1
- Initial build.

